#include <string>
#include <cstring>
#include <cctype>

// Copyright (C) 1992,2000 Bisqwit (http://iki.fi/bisqwit/).
//

#include "mididev.h"
#if !SIMPLE
#include "mudconn.h"
#endif
#include "music.h"
#include "terminal.h"

int main(int argc, const char *const *argv)
{
	mididev midi;
	terminal terminal;
	music music(&midi);
		
#if !SIMPLE
	if(!strcmp(argv[0], "miditester"))
	{
		if(midi.getfd() < 0)
		{
			fprintf(stderr, "Midi device failed initializing.\n");
			perror(argv[0]);
			return -1;
		}
		for(int a=1; a<argc; ++a)
		{
			FILE *fp = fopen(argv[a], "rb");
			if(!fp)continue;
			fseek(fp, 0, SEEK_END);
			unsigned size = ftell(fp);
			char *s = new char[size];
			if(s)
			{
				rewind(fp);
				fread(s, 1, size, fp);
				music.upload(s);
				delete[] s;
			}
			free(fp);
		}
#endif
		terminal.run(-1, music);
#if !SIMPLE
	}
	else
	{
		mudconn mudconn;
	    mudconn.open("10.0.0.5", 6134);
    	terminal.run(mudconn.getfd(), music);
    }
#endif
    
    return 0;
}
