//KOETA FLASHMAN THEME THN


#include <cstdio>
#include <string>
#include <cctype>
#include <vector>
#include <map>

static const char linebegin[] = "\33[2c";
static const char lineend[] = "\n";

static unsigned readword(FILE *fp, unsigned posi)
{
    fseek(fp, posi, SEEK_SET);
    unsigned char c = fgetc(fp);
    return (fgetc(fp) << 8) | c;
}

static string readstring(FILE *fp, unsigned posi, unsigned len=0)
{
    fseek(fp, posi, SEEK_SET);
    if(len)
    {
    	string Buf(len, ' ');
        fread(&Buf[0], len, 1, fp);
        return Buf;
    }
    string tmp;
    int c;
    while((c = fgetc(fp)))tmp += (char)c;
    return tmp;
}

static class instru
{
    unsigned readnum(const string &str, unsigned &posi)
    {
        unsigned tmp;
        for(tmp=0; isdigit(str[posi]); ++posi)
            tmp = tmp*10 + (str[posi]-'0');            
        return tmp;
    }

    int volmul;
    int defvol;
    
public:
	bool isadlib;
	
    int gmnum;
    int addi;
    int delay;

    instru() : volmul(64), defvol(64), isadlib(false), gmnum(0), addi(0), delay(0)
    {
    }
    void init(FILE *fp, unsigned posi)
    {
    	fseek(fp, posi, SEEK_SET);
    	if(fgetc(fp) == 2)isadlib = true;
    	
    	fseek(fp, posi+0x1C, SEEK_SET);
    	defvol = fgetc(fp);
    	
        string tmp = readstring(fp, posi+0x30);
        if(tmp[0] != 'G' || (tmp[1] != 'M' && tmp[1] != 'P'))
        {
        	fseek(fp, posi+0x24, SEEK_SET);
        	gmnum = fgetc(fp);
        	addi = (signed char)fgetc(fp);
        	if(!gmnum)addi=0;
        	else if(gmnum >= 128)gmnum = 128-gmnum;
        	return;
        }

        posi = 2;
        gmnum = readnum(tmp, posi);
        while(tmp[posi] != ':')
            switch(tmp[posi++])
            {
                case '/':
                    volmul = readnum(tmp, posi);
                    break;
                case '+':
                    addi += readnum(tmp, posi);
                    break;
                case '-':
                    addi -= readnum(tmp, posi);
                    break;
                case '%':
                    delay = readnum(tmp, posi);
                    break;
            }
        if(tmp[1] == 'P')gmnum = -gmnum;

        fprintf(stderr, "Instru name: '%s'\n", tmp.c_str());
    }
    int getvol(int &s3mvol, int v=-1) const
    {
    	if(v < 0)v = defvol;
    	
    	s3mvol = v>64 ? 64 : v;
    	
    	if(isadlib)
    	{
            static const unsigned char GMVol[64] =
            {
                /*00*/0x00,0x01,0x01,0x01, 0x01,0x01,0x01,0x02,
                /*08*/0x02,0x03,0x04,0x04, 0x05,0x06,0x07,0x08,
                /*16*/0x09,0x0A,0x0B,0x0C, 0x0D,0x0F,0x10,0x11,
                /*24*/0x13,0x15,0x16,0x18, 0x1A,0x1C,0x1E,0x1F,
                /*32*/0x22,0x24,0x26,0x28, 0x2A,0x2D,0x2F,0x31,
                /*40*/0x34,0x37,0x39,0x3C, 0x3F,0x42,0x45,0x47,
                /*48*/0x4B,0x4E,0x51,0x54, 0x57,0x5B,0x5E,0x61,
                /*56*/0x64,0x69,0x6C,0x70, 0x74,0x78,0x7C,0x7F,
            };
            if(v > 63)v = 63;            
    		v = GMVol[v] * volmul * 99 / 127 / 64;
    	}    	
    	else
    	{
    		v = v * volmul * 99 / 64 / 64;
    	}
    		
    	return v < 0 ? 0 : v > 99 ? 99 : v;
    }
} instru[100];

class patrow
{
public:
    unsigned char note, ins, volume, command, info;
    patrow() : note(255), ins(0), volume(255), command(255), info(0) { }
};

class patchannel
{
public:
    vector<patrow> row;
    vector<unsigned> speeds;
    void reserve(unsigned size) // varaudu
    {
    	row.resize(size);
    	speeds.resize(size);
    }
    unsigned size() const
    {
    	return row.size();
    }
    void clear()
    {
    	row.clear();
    	speeds.clear();
    }
private:
    bool something;
    void printf(const char *fmt, ...)
    {
    	char buf[512];
    	va_list ap;
    	va_start(ap, fmt);
    	vsprintf(buf, fmt, ap);
    	va_end(ap);                	
    	content += buf;
    }
    enum { pause, note, idle } mode;
    unsigned r, speed;
    unsigned wait;
    void flushwait(bool forcepiste=false)
    {
        if(wait > 0)
        {
            switch(mode)
            {
                case pause:
                    printf("p");
                    if(wait != speeds[r])printf("%u", wait);
                    break;
                case note:
                    if(wait != speeds[r])printf("%u", wait);
                    if(row[r].note == 255 || forcepiste)printf(".");
                    mode = idle;
                    break;
                case idle:
                    printf("y");
                    if(wait != speeds[r])printf("%u", wait);
                    break;
            }
            wait = 0;
        }
        flushspeed();
    }
    void flushspeed()
    {
        if(speed != speeds[r])
        {
        	speed = speeds[r];
        	flushwait();
	        printf("l%u", speed);
	    }
    }
public:
	unsigned title, newtitle;
	string content;
    void dumppa()
    {
        int inst=0; // into instru[]
        int ins=0, newins=0; // gmnums
        int vol=0, oct=200, s3mvol=0;
        unsigned dxxmemory=0;
        
        wait = 0;            
        mode = pause;

        something = false;
        content = "";
        
        speed = r = 0;
        
        flushwait();
        
        for(; r<size(); ++r)
        {
            unsigned i = row[r].ins;
            if(i)
            	newins = instru[inst = i-1].gmnum;
            
            // Preprocessing commands
            switch(row[r].command)
            {
            	case 'A'-64:
            		// This has been handled at main level.
            		//speed = row[r].info;
            		break;
            	case 'S'-64:
            		switch(row[r].info & 0xF0)
            		{
            			case 0xD0:
            				wait += row[r].info & 15;
            		}
            		break;
            	case 'M'-64:
            		switch(row[r].info & 0xF0)
            		{
            			case 0xB0:
            				flushwait();
            				printf("r%u", 99 * (row[r].info & 15) / 15);
            				break;
            			case 0xC0:
            			case 0xA0:
            				flushwait();
            				printf("h%u", 99 * (row[r].info & 15) / 15);
            				break;
            		}
            		break;
            	case 'X'-64:
            		flushwait();
            		printf("m%u", row[r].info * 99 / 255);
            		break;
            }
            
            int v = row[r].volume;
            if(v != 255)
            	v = instru[inst].getvol(s3mvol, v);
            else if(row[r].note < 255)
            {
            	/* inst has been handled at the top of this block */
            	v = instru[inst].getvol(s3mvol);
            }

            if(v != 255 && v != vol)
            {
                something = true;
                flushwait();
                printf("v%d", vol=v);
            }
            if(row[r].note < 255)
            {
                static const char notes[12][5] =
                    {"c","c+","d","d+","e","f",
                     "f+","g","g+","a","a+","b"};
                something = true;
                if(wait > 0)
                {
                    switch(mode)
                    {
                        case note: if(wait != speed)printf("%u", wait); break;
                        case pause: printf("p"); if(wait != speed)printf("%u", wait); break;
                        case idle:  printf("y"); if(wait != speed)printf("%u", wait); break;
                    }
                    wait = 0;
                }
                
                unsigned notenum = instru[inst].addi + (row[r].note&15) + (1 + (row[r].note>>4))*12;
                
                int o = notenum/12;
                if(o != oct)
                {
                    if(o == oct-1)printf("<");
                    else if(o == oct-2)printf("<<");
                    else if(o == oct+1)printf(">");
                    else if(o == oct+2)printf(">>");
                    else printf("o%u", o);
                    oct = o;
                }
                if(newins != ins)
                {
                    something = true;
                    printf("i%d", ins = newins);
                }
                flushspeed();
                printf("%s", notes[notenum%12]);
                mode = note;
            }
            
            flushspeed();            
            wait += speed;
            
            // Postprocessing commands
            switch(row[r].command)
            {
            	case 'S'-64:
            		switch(row[r].info & 0xF0)
            		{
            			// 0xE0, 0xB0 have been handled already.
            			case 0xD0:
            				wait -= (row[r].info & 15);
            		}
            		break;
            	case 'D'-64:
            	{
            		bool once = false;
            		int diff = row[r].info;
            		if(!diff) diff = dxxmemory; else dxxmemory = diff;
            		
            		if((diff & 0xF0) == 0xF0)
            		{
            			diff = -(diff & 0x0F);
            			once = true;
            		}
            		else if((diff & 0x0F) == 0x0F)
            		{
            			diff >>= 4;
            			once = true;
            		}
            		else if(diff >= 0x10)
            			diff >>= 4;
            		else
            			diff = -diff;
            		
            		if(!once)wait -= speed;
            		for(unsigned a=0; a<speed; ++a)
            		{
            		    if(!once)++wait;
            			v = s3mvol + diff;
            			v = instru[inst].getvol(s3mvol, v);
    		            if(v != vol)
    	    	        {
		        	        something = true;
	    		            flushwait(true);
    	    		        printf("v%d", vol=v);
        			    }        			
        			    if(once)break;
        			}
        		    break;
        		}
            }
        }
        if(wait > 0 && something)
            switch(mode)
            {
                case note: if(wait!=speed)printf("%u", wait); break;
                case pause: printf("p"); if(wait!=speed)printf("%u", wait); break;
                case idle:  printf("y"); if(wait!=speed)printf("%u", wait); break;
            }
        if(!something)content = "";
    }
};

class channelset
{
public:
    patchannel channel[32];
};

class pattern : public channelset
{
public:
	string content;
    void init(FILE *fp, unsigned length)
    {
        for(unsigned a=0; a<32; ++a)
        	channel[a].reserve(64);
        	
        for(unsigned row=0, p=0; p<length; ++p)
        {
            int tavu = fgetc(fp);

            if(tavu <= 0 || row >= 64) // All sorta mistakes handled
            {
                ++row;
                continue;
            }
            int chan = tavu&31;
            
            if(tavu&32)
            {
                channel[chan].row[row].note   = fgetc(fp);
                channel[chan].row[row].ins    = fgetc(fp);
                p += 2;
            }
            if(tavu&64)
            {
                channel[chan].row[row].volume = fgetc(fp);
                ++p;
            }
            if(tavu&128)
            {
                channel[chan].row[row].command= fgetc(fp);
                channel[chan].row[row].info   = fgetc(fp);
                p += 2;
            }
        }
  clearerr(fp);
    }
};

class track : public channelset
{
	bool loopstart;
public:
	unsigned size;
	vector<unsigned> speed;
	
	// key1: curord*64 + curord
	// key2: index into channel.row[]	
	map<unsigned, unsigned> ordrows;
	
	track() : loopstart(false), size(0)
	{
	}
	
	void clear()
	{
		loopstart = false;
		speed.clear();
		size = 0;
		for(unsigned a=0; a<32; ++a)
			channel[a].clear();
	}
	
	bool isloopstarter() const { return loopstart; }
	
	// Returns the first part, becomes the second part.
	// row specifies the number of rows to be included in first part.
	track split(unsigned row)
	{
		track first, second;
		second.loopstart = true;
		
		for(unsigned a=0; a<size; ++a)
			if(a < row)
				first.addrow(*this, a, speed[a]);
			else
				second.addrow(*this, a, speed[a]);
			
		*this = second;
		return first;
	}
	
	void addrow(channelset &pat, unsigned row, unsigned spd)
	{
		++size;
		speed.resize(size);   speed[size-1] = spd;
		
        for(unsigned a=0; a<32; ++a)
        {
        	channel[a].reserve(size);
        	channel[a].row[size-1]    = pat.channel[a].row[row];
        	channel[a].speeds[size-1] = spd;
        }
	}
};

class tracklist
{
public:
	unsigned begin, size;
	tracklist(unsigned b, unsigned s) : begin(b), size(s)
	{
	}
};

static class compress
{
	vector <string> elements;
	int phase;
public:
	compress() : phase(0)
	{
	}
	void ActionMessage()
	{
		switch(phase++)
		{
			case 0:
			case 1: fprintf(stderr, "Compressing"); break;
			case 2:
			case 3: fprintf(stderr, "Compressing more"); break;
			case 4: fprintf(stderr, "Compressing a bit more"); break;
			case 5: fprintf(stderr, "Compressing even a little more"); break;
			case 6: fprintf(stderr, "Compressing yet even more"); break;
			case 7: fprintf(stderr, "Ultimately shrinking"); break;
			case 8: fprintf(stderr, "Extensively compressing"); break;
			default: fprintf(stderr, "Crunching"); break;
		}		
		fprintf(stderr, "..."); fflush(stderr);
	}
	unsigned next(const string &jono, unsigned posi)
	{
		while(posi < jono.size())
		{
			posi++;
			
			if(jono[posi] != ':'
			&& jono[posi] != '-'
			&& jono[posi] != '+'
			&& jono[posi] != '.'
			&& !isdigit(jono[posi]))break;
		}
		return posi;
	}
	// kelpaako loopattavaksi elementiksi
	bool kelpaako(const string &jono)
	{
		unsigned defines=0, threads=0, loops=0;
		unsigned a, b=jono.size();
		for(a=0; a<b; ++a)
		{
			/***/if(jono[a] == '(') { if(defines++)return false; }
			else if(jono[a] == ')') { if(defines-- != 1)return false; }
			else if(jono[a] == '{') { ++threads; }
			else if(jono[a] == ',') { if(!threads)return false; }
			else if(jono[a] == '}') { if(!threads--)return false; }
			else if(jono[a] == '[') { ++loops; }
			else if(jono[a] == ']') { if(!loops--)return false; }
		}
		if(defines || threads || loops)return false;
		return true;
	}
	
	string elems(unsigned posi, unsigned count)
	{
		string tmp;
		while(count && posi < elements.size())
		{
			tmp += elements[posi++];
			count--;
		}
		return tmp;
	}
	
	string operator() (const string &jono)
	{
		string result =jono;
		ActionMessage();
	Redo:
		elements.clear();
		unsigned posi = 0;		
		while(posi < result.size())
		{
			unsigned p = next(result, posi);
			elements.push_back(result.substr(posi, p-posi));
			posi = p;
		}
		
		unsigned a, b=elements.size();
		for(a=0; a<b; a++)
		{
			unsigned bc=0, bco=0;
			unsigned c, bestsave=0;
			string testi;
			for(c=1; a+c < b; ++c)
			{
				testi = elems(a, c);
				if(!kelpaako(testi))continue;
				
				unsigned count;
				
				for(count=1; a + count*c < b; count++)
					if(testi != elems(a+count*c, c))
					    break;
				
				unsigned seivi = (count-1)*testi.size();
				if(seivi > bestsave)
				{
					bestsave = seivi;
					bc=c, bco=count;
				}
			}
			if(bestsave)
			{
				char Buf[64];
				sprintf(Buf, "[%d", bco);
				testi = elems(0, a);
				testi += Buf;
				testi += elems(a, bc);
				testi += ']';
				testi += elems(a + bco * bc, elements.size());
				
				if(testi.size() < result.size())
				{
					result = testi;
					fprintf(stderr, "."); fflush(stderr);
					goto Redo;
				}
			}
		}
		if(result.size() < jono.size())
		{
			/*
			fprintf(stderr, "\r"
				"Shrunk `%s'\n"
				"    to `%s'",
				jono.c_str(), result.c_str());				
			*/
    	}
    	else
    		phase = 0;
    	fprintf(stderr, "\n");
		return result;
	}
} compress;
    
static void kasittele(const char *fn)
{
    FILE *fp = fopen(fn, "rb");

    if(readstring(fp, 0x2C, 4) != "SCRM")
    {
        fclose(fp);
        fprintf(stderr, "File `%s' is not a S3M.\n", fn);
        return;
    }

    unsigned ordnum = readword(fp, 0x20);
    unsigned insnum = readword(fp, 0x22);
    unsigned patnum = readword(fp, 0x24);

    vector<unsigned char> orders(ordnum);
    vector<bool> ordervisited(ordnum);

    fseek(fp, 0x60, SEEK_SET);
    for(unsigned a=0; a<ordnum; ++a)
    {
    	orders[a] = fgetc(fp);
    	ordervisited[a] = false;
    }
    fprintf(stderr, "\n");

    vector<unsigned> patptr(patnum);

    for(unsigned a=0; a<insnum; ++a)
        instru[a].init(fp, readword(fp, 0x60 + ordnum + a*2)*16);

    for(unsigned a=0; a<patnum; ++a)
        patptr[a] = readword(fp, 0x60 + ordnum + insnum*2 + a*2);
    
    vector<pattern> pattern(patnum);
    
    for(unsigned a=0; a<patnum; ++a)
    {
        unsigned patlen = readword(fp, patptr[a]*16);
        pattern[a].init(fp, patlen);
    }
    
    unsigned curord=0;
    
    vector<tracklist> tracklists;
    vector<track> tracks;
    
    unsigned ekatrack = 0;
    
findmoreorders:
	fprintf(stderr, "Starting at order %u (pattern %u)\n", curord, orders[curord]);
    
    unsigned currow=0, curpat=orders[curord];
    fseek(fp, 0x31, SEEK_SET);
    unsigned speedi = fgetc(fp);

    // key1: ordrowptr
    // key2: index into tracks[]
    map<unsigned, unsigned> visited;
    
    unsigned char defins[32] = {1,1,1,1, 1,1,1,1, 1,1,1,1, 1,1,1,1,
                                1,1,1,1, 1,1,1,1, 1,1,1,1, 1,1,1,1};
    
    for(;;)
    {
    	track dest;
    	ordervisited[curord] = true;
    	
    	unsigned loopstart=0, loopcounter=0;
    	
    enhancetrack:
    	if(!loopcounter)
    	{
        	unsigned ordrowptr = curord * 64 + currow;
        	if(visited.find(ordrowptr) != visited.end())
        	{
        		if(dest.size)tracks.push_back(dest);
        		
        		unsigned n = visited[ordrowptr];
        		unsigned r = tracks[n].ordrows[ordrowptr];
        		
        		vector<track>::iterator i = tracks.begin() + n;
        		
        		track tmp = i->split(r);
        		if(tmp.size)tracks.insert(i, tmp);
        		break;
        	}
        	
        	visited[ordrowptr] = tracks.size();    	
        	dest.ordrows[ordrowptr] = dest.size;
    	}
    	
    	enum { donotloop, reloop, afterloop } loopway = donotloop;
    	
    	int brk = -1;
    	int cut = -1;
    	
   // 	fprintf(stderr, "Pattern %u, Line %u, LoopStart=%u, LoopWay=%u, LoopCounter=%u\n",
   // 		curpat, currow, loopstart, loopway, loopcounter);
    	
    	channelset thisrow = pattern[curpat];
    	
    	unsigned patternpause = 0;
    	for(unsigned a=0; a<32; ++a)
    	{
	    	patrow &tmp = thisrow.channel[a].row[currow];
	    	switch(tmp.command)
	    	{
	    		case 'S'-64:
	    			switch(tmp.info & 0xF0)
	    			{
	    				case 0xB0:
	    					if(tmp.info == 0xB0)
	    						loopstart = currow;
	    					else
	    					{
	    						loopway = reloop;
	    						if(!loopcounter)
	    							loopcounter = tmp.info & 15;
	    						else if(!--loopcounter)
	    							loopway = afterloop;
	    					}
	    					break;
	    				case 0xE0:
	    					patternpause = tmp.info & 15;
	    					break;
	    			}
	    			break;
	    		case 'A'-64:
	    			// flushing dest here would be a solution to
	    			// speed controlling problems, but it would
	    			// break notes.
	    			speedi = tmp.info;
	    			break;
	    		case 'B'-64: brk    = tmp.info; break;
	    		case 'C'-64: cut    = (tmp.info/16) * 10 + (tmp.info&15); break;
	    	}
	    	if(tmp.ins)
	    		defins[a] = tmp.ins;
	    	else
	    		tmp.ins = defins[a];
	  	}
	  	
	  	// Add the row _after_ the commands (Axx etc) have been handled.

    	dest.addrow(thisrow, currow, speedi);
    	if(patternpause)
    	{
    		for(unsigned a=0; a<32; ++a)
    		{
		    	patrow &tmp = thisrow.channel[a].row[currow];
		    	tmp.ins    = 0;
		    	tmp.volume = 255;
		    	tmp.note   = 255;
    		}
    		while(patternpause--) dest.addrow(thisrow, currow, speedi);
    	}
    	
    	if(loopway == reloop)
    	{
    		currow = loopstart;
    		goto enhancetrack;
    	}
	  	if(brk >= 0)
	  	{
	  		fprintf(stderr, "B%02X C%02X\n", brk, cut);
	  		curpat = orders[curord = brk];
	  		currow = cut < 0 ? 0 : cut;
	  	}
	  	else if(currow == 63 || cut >= 0)
	  	{
	  		fprintf(stderr, "Order %u ended", curord);
	  		if(cut >= 0)fprintf(stderr, " with C%02X,", cut);
	  		fprintf(stderr, " %u rows long\n", currow+1);
	  		++curord;
	  	orderloop:
	  		switch(orders[curord])
	  		{
	  			case 255: curord=0; goto orderloop;
	  			case 254: ++curord; goto orderloop;
	  			default: curpat = orders[curord];
	  		}
	  		currow = loopstart = cut < 0 ? 0 : cut;
	  	}
	  	else
	  	{
	  		++currow;
	  		if(loopway == afterloop)
	  		{
	  			loopway = donotloop;
	  			loopstart = currow;
	  		}
	  		goto enhancetrack;
	  	}
  		if(dest.size)tracks.push_back(dest);
  		// dest will be cleared here as the
  		// for-loop recreates the variables inside.
    }
    
    {tracklist thistracklist(ekatrack, tracks.size()-ekatrack);
    tracklists.push_back(thistracklist);}
    
    for(unsigned a=0; a<ordnum; ++a)
    	if(!ordervisited[a] && orders[a]<254)
    	{
    		ekatrack = tracks.size();
    		curord = a;
    		// mars mars!
    		goto findmoreorders;
    	}

    map<unsigned, string> contents;
    map<unsigned, unsigned> backlink;
    
    // Generate contents and titles.

    for(unsigned a=0; a<tracks.size(); ++a)
        for(unsigned b=0; b<32; ++b)
        {
        	tracks[a].channel[b].dumppa();
        	
        	tracks[a].channel[b].title = a * 32 + b + tracks.size() + 1;
       		
        	contents[tracks[a].channel[b].title] =
        	         tracks[a].channel[b].content;
       	}
    
    // Find doubles and generate backlinks.
    
    map<unsigned, string>::iterator i, j;
    for(i=contents.begin(); i!=contents.end(); ++i)
    	for(j=contents.begin(); j!=i; ++j)
    		if(i->second == j->second)
    		{
    			backlink[i->first] = j->first;
    			break;
	    	}
	
    unsigned titlecounter = tracklists.size() + tracks.size() + 1;
    
    printf("%s", linebegin);
    
    // Generate new names for them.
    
    for(unsigned a=0; a<tracks.size(); ++a)
        for(unsigned b=0; b<32; ++b)
        {
        	unsigned title = tracks[a].channel[b].title;
        	if(backlink.find(title) == backlink.end())
        	{
        		const string &s = tracks[a].channel[b].content.c_str();
        		if(s.size())
	        		printf("(%u%s)",
	        			(tracks[a].channel[b].newtitle = titlecounter++),
	        			compress(s).c_str());
	        }
	        else
	        {
	        	// Make a ridiculous name for a
	        	// track that will not be output.
	        	// Must be distinguishable name, however.
	        	tracks[a].channel[b].newtitle = 10000 + tracks[a].channel[b].title;
	       	}
        }
    
    backlink.clear();
    contents.clear();
    
    // Rewrite the tables with the new names.
    
    for(unsigned a=0; a<tracks.size(); ++a)
        for(unsigned b=0; b<32; ++b)
        	contents[tracks[a].channel[b].newtitle] =
        	         tracks[a].channel[b].content;
    
    for(i=contents.begin(); i!=contents.end(); ++i)
    	for(j=contents.begin(); j!=i; ++j)
    		if(i->second == j->second)
    		{
    			backlink[i->first] = j->first;
    			break;
	    	}	

    // Describe all tracks.
    
    unsigned firsttitle = tracklists.size();
    
    for(unsigned a=0; a<tracks.size(); ++a)
    {
        printf("(%u{", a+firsttitle);
        bool c=false;
        for(unsigned b=0; b<32; ++b)
        {
        	unsigned title = tracks[a].channel[b].newtitle;
        	map<unsigned, unsigned>::iterator i = backlink.find(title);
        	unsigned link = (i == backlink.end()) ? 0 : i->second;
        	string &s = contents[link ? link : title];
        	if(s.size())
        	{
	        	if(c)printf(",");else c=true;
    	    	printf("x%u", link ? link : title);
    	   	}
        }
        printf("})");
    }
    
    // Write each list of tracks.
    
    for(unsigned b=0; b<tracklists.size(); ++b)
    {
        unsigned c=0;
        for(unsigned a=tracklists[b].begin; c<tracklists[b].size; ++a)
        {
            if(!c++)printf("(%u/4", b);
            if(tracks[a].isloopstarter())printf("[");
            printf("x%d", a+firsttitle);
        }
        if(c)printf("])");
    }
    
    printf("%s", lineend);
    
    fclose(fp);
}

int main(int argc, const char *const *argv)
{                                        
    for(int a=1; a<argc; ++a)
        kasittele(argv[a]);
    return 0;
}
